import os,json, copy
from glob import glob

name="Drug-Drug Interaction"

path=os.path.dirname(os.path.realpath(__file__))
with open(os.path.join(path, "alternative-names.json")) as file:
    altname=json.loads(file.read())

def save(prescription):
    return(run(prescription, False))

def run(prescription, msg_if_none=True):
    medication=copy.deepcopy(prescription.medication)
    for i in altname:
        medication=medication.lower().replace(i, altname[i])
    drugs=[os.path.basename(i) for i in glob(os.path.join(path, "interactions", "*"))]
    medlist=[]
    for drug in drugs:
        if(drug in medication):
            medlist.append(drug)
            try:
                medlist.append(altname[drug])
            except:
                pass
    interactions=[]
    for drug in medlist:
        with open(os.path.join(path, "interactions", drug)) as file:
            for line in file:
                for d in medlist:
                    if(d in line and d != drug):
                        inter=[drug, d]
                        inter.sort()
                        inter.append(line.split(",")[0])
                        if inter not in interactions:
                            interactions.append(inter)
    if(len(interactions)>0):
        message="<strong>Potential interactions</strong>:<ul>"
        for i in interactions:
            message=message+"<li>"+i[0].capitalize()+", "+i[1].capitalize()+" ("+i[2].capitalize()+")</li>"
        message=message+"</ul><br>(Experimental feature. May contain omissions/errors.)"
    else:
        if(msg_if_none):
            message="No interaction could be detected.<br>(Experimental feature. May contain omissions/errors.)"
    return(message)
